=begin
v.3

version 3:
Added TIGs code to find all faces, so works on entire model
Added another method to check for non-triangular faces
Faces that dont match the parameters are now added to the selection
=end

def ngon_check(n_of_sides)

model = Sketchup.active_model
entities = model.active_entities
selection = model.selection

selection.clear

faces=[]

model.entities.each{|e|faces<< e if e.class==Sketchup::Face}
model.definitions.each{|d|d.entities.each{|e|faces<< e if e.class==Sketchup::Face}}

n = 0

faces.each{|e|
  if e.is_a? Sketchup::Face and e.edges.length > n_of_sides
      n += 1  
      selection.add(e)	  
  end
}

if n > 0
  UI.messagebox("Contains #{n} N-Gons")
else
  UI.messagebox("N-gon free!")
end

end #method

def tri_check()

model = Sketchup.active_model
entities = model.active_entities
selection = model.selection

selection.clear

faces=[]

model.entities.each{|e|faces<< e if e.class==Sketchup::Face}
model.definitions.each{|d|d.entities.each{|e|faces<< e if e.class==Sketchup::Face}}

n = 0

faces.each{|e|
  if e.is_a? Sketchup::Face and e.edges.length >= 4
      n += 1  
	  selection.add(e)
  end
}

if n > 0
  UI.messagebox("Contains #{n} non triangulated faces")
else
  UI.messagebox("It's all triangles here")
end

end #method

UI.menu("Plugins").add_item("N-Gon Check"){ngon_check(4)}

